.386
.MODEL FLAT, STDCALL
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\masm32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\masm32.lib

return MACRO ARG
	IFNB <ARG>
		IF (OPATTR (ARG)) AND 00000100y
			IF ARG EQ 0
				xor eax, eax
			ELSE
				mov eax, ARG
			ENDIF
		ELSEIFDIFI <eax>, <ARG>
			mov eax, ARG
		ENDIF
	ENDIF
	ret
ENDM

FileToBuff	PROTO :DWORD, :DWORD
WriteToDisk	PROTO

.data

szBoot		db "C:\Projects\QuickProjects\OS\Boot\Boot.com", 0
szTrans		db "C:\Projects\QuickProjects\OS\Transition\Transition.com", 0
szSystem32	db "C:\Projects\QuickProjects\OS\System32\System32.com", 0
;szDest		db "\\.\A:", 0
szDest		db "C:\Program Files\Bochs-2.1.1\perspective.img", 0

szWrit		db "Writing sector...", 0Dh, 0Ah, 0
szComp		db "Operation complete!", 0Dh, 0Ah, 0Dh, 0Ah, 0
szFail		db "Operation failed!", 0Dh, 0Ah, 0Dh, 0Ah, 0
szRead		db "Read %d, Used %d, Total Used %d", 0Dh, 0Ah, 0
szDat		db "bNumSecs = %d; wEntry = %d", 0Dh, 0Ah, 0

dwRead		dd 0

.data?

bBuffer		db (32*1024) dup (?)

bRubbish	db (100*1024) dup (?)

.code
start:

invoke FileToBuff, addr szBoot, 7C00h
.if eax!=TRUE
	invoke StdOut, addr szFail
	invoke ExitProcess, 0
.endif

invoke FileToBuff, addr szTrans, 7E00h
.if eax!=TRUE
	invoke StdOut, addr szFail
	invoke ExitProcess, 0
.endif

invoke FileToBuff, addr szSystem32, 8C00h
.if eax!=TRUE
	invoke StdOut, addr szFail
	invoke ExitProcess, 0
.endif

mov edx, dwRead
mov ecx, edx
shr ecx, 9
and edx, 01FFh
jz @F
inc ecx
@@:
dec ecx

xor edx, edx
invoke wsprintf, addr bRubbish, addr szDat, ecx, edx
invoke StdOut, addr bRubbish

invoke WriteToDisk
.if eax!=TRUE
	invoke StdOut, addr szFail
	invoke ExitProcess, 0
.endif

invoke StdOut, addr szComp

invoke ExitProcess, 0

FileToBuff PROC pszFile:DWORD, pStart:DWORD
	LOCAL hFile:DWORD
	LOCAL dwThisRead:DWORD

	invoke CreateFile, pszFile, GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL
	
	.if eax==INVALID_HANDLE_VALUE
		return FALSE
	.endif
	
	mov hFile, eax
	
	invoke ReadFile, hFile, addr bRubbish, 100*1024, addr dwThisRead, NULL
	
	.if eax==0
		invoke CloseHandle, hFile
		return FALSE
	.endif
	
	invoke CloseHandle, hFile
	
	mov edi, offset bBuffer
	add edi, dwRead
	
	mov esi, offset bRubbish
	add esi, pStart
	
	mov ecx, dwThisRead
	sub ecx, pStart
	
	push ecx
	
	add dwRead, ecx

	rep movsb
	
	pop ecx
	
	invoke wsprintf, addr bRubbish, addr szRead, dwThisRead, ecx, dwRead
	invoke StdOut, addr bRubbish
	
	return TRUE
FileToBuff ENDP

WriteToDisk PROC
	LOCAL hDisk:DWORD
	LOCAL dwWritten:DWORD
	LOCAL dwReadLocal:DWORD
	LOCAL pBuf:DWORD

	mov edx, dwRead	
	mov dwReadLocal, edx
	
	mov edx, offset bBuffer
	mov pBuf, edx

	invoke CreateFile, addr szDest, GENERIC_WRITE, NULL, NULL, CREATE_ALWAYS, NULL, NULL
	
	.if eax==INVALID_HANDLE_VALUE
		return FALSE
	.endif
	
	mov hDisk, eax

WriteToDisk_Loop:
	
	invoke StdOut, addr szWrit
	invoke WriteFile, hDisk, pBuf, 512, addr dwWritten, NULL
	
	.if eax==0
		invoke CloseHandle, hDisk
		
		return FALSE
	.endif

	add pBuf, 512
	sub dwReadLocal, 512
	mov eax, dwReadLocal
	cmp eax, 512
	ja  WriteToDisk_Loop
	
	invoke StdOut, addr szWrit
	invoke WriteFile, hDisk, pBuf, 512, addr dwWritten, NULL
	
	.if eax==0
		invoke CloseHandle, hDisk
		
		return FALSE
	.endif
	
	invoke CloseHandle, hDisk
	
	return TRUE
WriteToDisk ENDP

end start
